From 63f92e8283800e532ea3a4dd017aae73bbf31f34 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: May 01 2020 05:55:23 +0000
Subject: [PATCH 504/2232] Preserve Span of namespace segments


---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index eb72ba4..8b554d8 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -938,7 +938,7 @@ fn to_typename(namespace: &Namespace, ty: &Type) -> String {
         Type::Ident(ident) => {
             let mut path = String::new();
             for name in namespace {
-                path += name;
+                path += &name.to_string();
                 path += "::";
             }
             path += &ident.to_string();
@@ -1018,7 +1018,7 @@ fn write_generic_instantiations(out: &mut OutFile, types: &Types) {
 fn write_rust_box_extern(out: &mut OutFile, ident: &Ident) {
     let mut inner = String::new();
     for name in &out.namespace {
-        inner += name;
+        inner += &name.to_string();
         inner += "::";
     }
     inner += &ident.to_string();
@@ -1077,7 +1077,7 @@ fn write_rust_vec_extern(out: &mut OutFile, element: &Ident) {
 fn write_rust_box_impl(out: &mut OutFile, ident: &Ident) {
     let mut inner = String::new();
     for name in &out.namespace {
-        inner += name;
+        inner += &name.to_string();
         inner += "::";
     }
     inner += &ident.to_string();
diff --git a/syntax/namespace.rs b/syntax/namespace.rs
index d26bb9e..5230eb6 100644
--- a/syntax/namespace.rs
+++ b/syntax/namespace.rs
@@ -3,7 +3,7 @@ use quote::IdentFragment;
 use std::fmt::{self, Display};
 use std::slice::Iter;
 use syn::parse::{Parse, ParseStream, Result};
-use syn::{Path, Token};
+use syn::{Ident, Path, Token};
 
 mod kw {
     syn::custom_keyword!(namespace);
@@ -11,7 +11,7 @@ mod kw {
 
 #[derive(Clone)]
 pub struct Namespace {
-    segments: Vec<String>,
+    segments: Vec<Ident>,
 }
 
 impl Namespace {
@@ -21,7 +21,7 @@ impl Namespace {
         }
     }
 
-    pub fn iter(&self) -> Iter<String> {
+    pub fn iter(&self) -> Iter<Ident> {
         self.segments.iter()
     }
 }
@@ -35,7 +35,7 @@ impl Parse for Namespace {
             let path = input.call(Path::parse_mod_style)?;
             for segment in path.segments {
                 ident::check(&segment.ident)?;
-                segments.push(segment.ident.to_string());
+                segments.push(segment.ident);
             }
             input.parse::<Option<Token![,]>>()?;
         }
@@ -46,8 +46,7 @@ impl Parse for Namespace {
 impl Display for Namespace {
     fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
         for segment in self {
-            f.write_str(segment)?;
-            f.write_str("$")?;
+            write!(f, "{}$", segment)?;
         }
         Ok(())
     }
@@ -60,8 +59,8 @@ impl IdentFragment for Namespace {
 }
 
 impl<'a> IntoIterator for &'a Namespace {
-    type Item = &'a String;
-    type IntoIter = Iter<'a, String>;
+    type Item = &'a Ident;
+    type IntoIter = Iter<'a, Ident>;
     fn into_iter(self) -> Self::IntoIter {
         self.iter()
     }

